package wallet

type SupportRes struct {
	Success bool     `json:"success" dc:"是否成功"`
	Data    []string `json:"data"`
}

type TransactionHistoryRes struct {
	Success bool `json:"success" dc:"请求是否成功"`
	Data    Data `json:"data" dc:"交易数据"`
}

type ContractLabelMetadata struct {
	Icon string `json:"icon" dc:"合约标签元数据图标"`
}

type ContractLabel struct {
	Address  string                `json:"address" dc:"合约地址"`
	Name     string                `json:"name" dc:"合约名称"`
	Metadata ContractLabelMetadata `json:"metadata" dc:"合约标签元数据"`
}

type BalanceChange struct {
	Amount   float64 `json:"amount" dc:"余额变动金额"`
	Symbol   string  `json:"symbol" dc:"代币符号"`
	Name     string  `json:"name" dc:"代币名称"`
	Decimals int     `json:"decimals" dc:"代币精度"`
	Address  string  `json:"address" dc:"代币地址"`
	LogoURI  string  `json:"logoURI" dc:"代币Logo链接"`
}

type Transaction struct {
	TxHash        string          `json:"txHash" dc:"交易哈希"`
	BlockNumber   uint64          `json:"blockNumber" dc:"区块编号"`
	BlockTime     string          `json:"blockTime" dc:"区块时间"`
	Status        bool            `json:"status" dc:"交易状态"`
	From          string          `json:"from" dc:"发送方"`
	To            string          `json:"to" dc:"接收方"`
	Fee           int             `json:"fee" dc:"交易费用"`
	MainAction    string          `json:"mainAction" dc:"主要操作"`
	BalanceChange []BalanceChange `json:"balanceChange" dc:"余额变动"`
	ContractLabel ContractLabel   `json:"contractLabel" dc:"合约标签"`
}

type Data struct {
	Solana []Transaction `json:"solana" dc:"Solana链的交易数据"`
}
